"{ Package: 'jn:refactoring_custom' }"

CustomCodeGeneratorOrRefactoringTestCase subclass:#CustomAddClassChangeTests
	instanceVariableNames:'className change'
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Refactoring-Custom-Tests'
!

!CustomAddClassChangeTests methodsFor:'accessing'!

generatorOrRefactoring

    ^ nil

    "Created: / 16-10-2014 / 22:57:00 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomAddClassChangeTests methodsFor:'initialize & release'!

setUp
    super setUp.

    className := 'DummyTestClass01'.
    self assert: (Smalltalk classNamed: className) isNil.    

    change := AddClassChange definition: '
    Object subclass:#', className, '
        instanceVariableNames:''''
        classVariableNames:''''
        poolDictionaries:''''
        category:''''
    '.

    "Modified: / 16-10-2014 / 22:55:24 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

tearDown
    | realClass |
    
    realClass := Smalltalk classNamed: className.
    realClass notNil ifTrue: [ 
        realClass removeFromSystem
    ].

    super tearDown.

    "Modified: / 16-10-2014 / 22:59:29 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomAddClassChangeTests methodsFor:'tests'!

test_get_and_set_package

    self assert: change package isNil.

    change package: #some_package01.

    self assert: #some_package01 = (change package).

    "Created: / 17-10-2014 / 09:06:07 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

test_primitive_execute_with_package

    | class |

    change package: #some_package01.
    change primitiveExecute.

    self assertClassExists: className.
    class := Smalltalk classNamed: className.
    self assert: #some_package01 = (class package).

    "Created: / 16-10-2014 / 22:49:48 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
    "Modified (format): / 17-10-2014 / 08:10:04 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

test_primitive_execute_without_package

    | class |

    change primitiveExecute.

    self assertClassExists: className.
    class := Smalltalk classNamed: className.
    self assert: (PackageId noProjectID) = (class package).

    "Created: / 17-10-2014 / 08:11:34 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

