"{ Package: 'jn:refactoring_custom' }"

Object subclass:#CustomSourceCodeSelection
	instanceVariableNames:'selectedInterval currentSourceCode selectedMethod selectedClass
		selectedSelector'
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Refactoring-Custom'
!

!CustomSourceCodeSelection class methodsFor:'documentation'!

documentation
"
    Container class which holds actual source code from text editor (source code editor) 
    with exact position of selected source code. Also keeps corresponding class, method and selector
    to current source code.

    [author:]
        Jakub Nesveda <nesvejak@fit.cvut.cz>

"
! !

!CustomSourceCodeSelection methodsFor:'accessing'!

currentSourceCode

    currentSourceCode notNil ifTrue: [ 
        ^ currentSourceCode
    ].

    self selectedMethod notNil ifTrue: [ 
        ^ self selectedMethod source
    ].

    (self selectedSelector notNil and: [self selectedClass notNil]) ifTrue: [ 
        ^ (self selectedClass compiledMethodAt: self selectedSelector asSymbol) source
    ].

    ^ nil

    "Modified: / 24-08-2014 / 22:29:57 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

currentSourceCode:something
    currentSourceCode := something.
!

selectedClass
    ^ selectedClass
!

selectedClass:something
    selectedClass := something.
!

selectedInterval
    ^ selectedInterval
!

selectedInterval:something
    selectedInterval := something.
!

selectedMethod
    ^ selectedMethod
!

selectedMethod:something
    selectedMethod := something.
!

selectedSelector
    ^ selectedSelector
!

selectedSelector:something
    selectedSelector := something.
!

selectedSourceCode
    "Returns selectedSourceCode fragment as string from selectedInterval"

    | source interval |

    source := self currentSourceCode asString.
    interval := self selectedInterval.

    (interval isNil or: [ interval isEmpty ]) ifTrue: [ 
        ^ nil
    ].

    (interval first between: 1 and: source size) ifFalse: [ 
        self error: 'selectedInterval is not within source range'
    ].

    ^ source copyFrom: interval first to: (interval last min:source size)

    "Created: / 24-08-2014 / 22:18:53 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
    "Modified: / 14-10-2014 / 10:27:29 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomSourceCodeSelection class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

