"{ Package: 'jn:refactoring_custom' }"

TestCase subclass:#CustomSourceCodeSelectionTests
	instanceVariableNames:'codeSelection'
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Refactoring-Custom-Tests'
!


!CustomSourceCodeSelectionTests methodsFor:'initialization & release'!

setUp

    codeSelection := CustomSourceCodeSelection new.

    "Created: / 24-08-2014 / 22:51:50 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomSourceCodeSelectionTests methodsFor:'tests'!

test_current_source_code_class_and_selector_filled

    codeSelection 
        selectedClass: self class;
        selectedSelector: #setUp.    
    
    self assert: (codeSelection currentSourceCode startsWith: 'setUp').

    "Created: / 24-08-2014 / 22:56:33 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

test_current_source_code_filled

    codeSelection currentSourceCode: 'src'.
    
    self assert: codeSelection currentSourceCode = 'src'.

    "Created: / 24-08-2014 / 22:54:09 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

test_current_source_code_method_filled

    codeSelection selectedMethod: (self class compiledMethodAt: #setUp).    
    
    self assert: (codeSelection currentSourceCode startsWith: 'setUp').

    "Created: / 24-08-2014 / 22:55:25 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

test_current_source_code_not_filled
    
    self assert: codeSelection currentSourceCode isNil.

    "Created: / 24-08-2014 / 22:57:47 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

test_selected_source_code_part_code

    codeSelection
        currentSourceCode: 'selector ^ self otherSelector.';
        selectedInterval: (12 to: 15).

    self assert: codeSelection selectedSourceCode = 'self'.

    "Created: / 24-08-2014 / 23:06:10 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

test_selected_source_code_whole_code

    codeSelection
        currentSourceCode: 'selector ^ self otherSelector.';
        selectedInterval: (1 to: 30).

    self assert: codeSelection selectedSourceCode = 'selector ^ self otherSelector.'.

    "Created: / 24-08-2014 / 22:58:19 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

test_selected_source_interval_empty

    codeSelection
        currentSourceCode: 'selector ^ self otherSelector.';
        selectedInterval: (1 to: 0).

    self assert: codeSelection selectedSourceCode isNil.

    "Created: / 14-10-2014 / 10:22:52 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

test_selected_source_unknown

    codeSelection
        currentSourceCode: 'selector ^ self otherSelector.'.

    self assert: codeSelection selectedSourceCode isNil.

    "Created: / 14-10-2014 / 10:19:44 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!CustomSourceCodeSelectionTests class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

