"{ Package: 'jn:refactoring_custom' }"

CustomCodeGeneratorOrRefactoringTestCase subclass:#CustomTestCaseCodeGeneratorTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Refactoring-Custom-Generators-Tests'
!

!CustomTestCaseCodeGeneratorTests methodsFor:'accessing'!

generatorOrRefactoring
    ^CustomTestCaseCodeGenerator new
! !

!CustomTestCaseCodeGeneratorTests methodsFor:'tests'!

test_test_category_ending_with_tests
    | expectedCategory actualCategory |

    expectedCategory := 'Some-Category-Tests'.
    actualCategory := generatorOrRefactoring testCategory:'Some-Category-Tests'.    

    self assert: expectedCategory equals: actualCategory.

    "Created: / 30-08-2014 / 22:06:14 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

test_test_category_ending_without_tests
    | expectedCategory actualCategory |

    expectedCategory := 'Some-Category-Tests'.
    actualCategory := generatorOrRefactoring testCategory:'Some-Category'.    

    self assert: expectedCategory equals: actualCategory.

    "Created: / 30-08-2014 / 22:07:13 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
!

test_test_class_generated_for_metaclass
    | class |

    class := self classWithInstanceVariable.

    self assertClassNotExists: class name.

    context selectedClasses: (Array with: class theMetaclass ).
    generatorOrRefactoring
        configureInContext: context;
        executeInContext: context.

    self assertClassExists: class name

    "Created: / 14-10-2014 / 10:42:20 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

