"{ Package: 'jn:refactoring_custom' }"

CustomDialog subclass:#CustomUserDialog
	instanceVariableNames:'dialog'
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Refactoring-Custom'
!

!CustomUserDialog class methodsFor:'documentation'!

documentation
"
    CustomDialog implementation with real dialogs to provide human interaction.
    Currently it is a simple wrapper around DialogBox. 

    [author:]
        Jakub Nesveda <nesvejak@fit.cvut.cz>

"
! !

!CustomUserDialog class methodsFor:'instance creation'!

new
    "return an initialized instance"

    ^ self basicNew initialize.
! !

!CustomUserDialog methodsFor:'construction-adding'!

addAbortAndOkButtons
    dialog addAbortAndOkButtons

    "Created: / 15-09-2014 / 16:21:46 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

addComponent:aView
    "Add given component. Component is automatically stretched to occupy windows' width"

    ^ dialog addComponent: aView

    "Created: / 15-09-2014 / 18:50:05 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

addComponent:aView labeled:aString
    "Add a label and some component side-by-side. Returns the component"

"/    aString notEmptyOrNil ifTrue:[
        ^ dialog
            addLabelledField:aView 
            label:aString ? ''
            adjust:#left 
            tabable:true 
            separateAtX:0.3
"/    ] ifFalse:[ 
"/        ^ dialog
"/            addComponent:aView indent: 0.3
"/    ].

    "Created: / 15-09-2014 / 15:45:40 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 15-09-2014 / 19:44:41 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CustomUserDialog methodsFor:'initialization'!

initialize
    "Invoked when a new instance is created."

    "/ please change as required (and remove this comment)
    dialog := DialogBox new.
    dialog abortAction: [ AbortOperationRequest raiseRequest ]  

    "/ super initialize.   -- commented since inherited method does nothing

    "Modified: / 15-09-2014 / 16:23:01 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CustomUserDialog methodsFor:'opening'!

open
    ^ dialog open

    "Created: / 15-09-2014 / 16:23:41 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!CustomUserDialog methodsFor:'user interaction & notifications'!

information: aString

    ^ Dialog information: aString

    "Created: / 02-06-2014 / 22:36:58 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
    "Modified: / 22-07-2014 / 21:25:18 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

