"{ Package: 'jn:refactoring_custom' }"

LibraryDefinition subclass:#jn_refactoring_custom
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!jn_refactoring_custom class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

mandatoryPreRequisites
    "list packages which are mandatory as a prerequisite.
     This are packages containing superclasses of my classes and classes which
     are extended by myself.
     They are mandatory, because we need these packages as a prerequisite for loading and compiling.
     This method is generated automatically,
     by searching along the inheritance chain of all of my classes."

    ^ #(
        #'stx:goodies/refactoryBrowser/changes'    "AddClassChange - extended"
        #'stx:goodies/refactoryBrowser/helpers'    "RBAbstractClass - extended"
        #'stx:goodies/refactoryBrowser/parser'    "ParseTreeRewriter - superclass of CustomParseTreeRewriter"
        #'stx:goodies/refactoryBrowser/refactoring'    "RefactoryBuilder - superclass of CustomRefactoryBuilder"
        #'stx:goodies/sunit'    "TestAsserter - superclass of CustomAccessMethodsCodeGeneratorTests"
        #'stx:libbasic'    "LibraryDefinition - superclass of jn_refactoring_custom"
        #'stx:libtool'    "CodeGenerator - superclass of CustomSourceCodeGenerator"
        #'stx:libview2'    "ApplicationModel - extended"
    )
!

referencedPreRequisites
    "list packages which are a prerequisite, because they contain
     classes which are referenced by my classes.
     We do not need these packages as a prerequisite for loading or compiling.
     This method is generated automatically,
     by searching all classes (and their packages) which are referenced by my classes."

    ^ #(
        #'stx:libbasic3'    "Change - referenced by CustomCodeGeneratorOrRefactoringTestCase>>assertSource:sameAs:"
        #'stx:libcomp'    "Parser - referenced by CustomNamespace>>createMethodImmediate:protocol:source:package:"
        #'stx:libview'    "WindowGroup - referenced by CustomCodeGeneratorOrRefactoring>>executeInContextWithWaitCursor:"
        #'stx:libwidg'    "DialogBox - referenced by CustomUserDialog>>initialize"
        #'stx:libwidg2'    "CheckBox - referenced by CustomDialog>>addCheckBoxOn:labeled:"
    )
!

subProjects
    "list packages which are known as subprojects.
     The generated makefile will enter those and make there as well.
     However: they are not forced to be loaded when a package is loaded;
     for those, redefine requiredPrerequisites"

    ^ #(
    )
! !

!jn_refactoring_custom class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        CustomChangeManager
        CustomClassQuery
        (CustomClassQueryTests autoload)
        CustomCodeGeneratorOrRefactoring
        (CustomCodeGeneratorOrRefactoringTestCase autoload)
        CustomContext
        CustomDialog
        (CustomDummyTests autoload)
        CustomManager
        CustomMenuBuilder
        CustomMock
        (CustomMockTests autoload)
        CustomNamespace
        (CustomNoneSourceCodeFormatterTests autoload)
        CustomParseTreeRewriter
        CustomPerspective
        (CustomPerspectiveTests autoload)
        (CustomRBAbstractClassTests autoload)
        (CustomRBClassTests autoload)
        (CustomRBLocalSourceCodeFormatterTests autoload)
        (CustomRBMethodTests autoload)
        CustomRefactoryBuilder
        CustomSourceCodeFormatter
        CustomSourceCodeGenerator
        (CustomSourceCodeGeneratorTests autoload)
        CustomSourceCodeSelection
        (CustomSourceCodeSelectionTests autoload)
        TestClass
        TestClass2
        #'jn_refactoring_custom'
        (CustomAccessMethodsCodeGeneratorTests autoload)
        (CustomAddClassChangeTests autoload)
        (CustomAddMethodChangeTests autoload)
        CustomBrowserChangeManager
        CustomBrowserContext
        (CustomChangeNotificationAccessMethodsCodeGeneratorTests autoload)
        (CustomChangeNotificationSetterMethodsCodeGeneratorTests autoload)
        CustomCodeGenerator
        (CustomCodeGeneratorClassGeneratorTests autoload)
        (CustomCodeGeneratorTests autoload)
        (CustomCodeGeneratorUserPreferencesTests autoload)
        (CustomCodeSelectionToResourceTranslationTests autoload)
        (CustomDefaultGetterMethodsCodeGeneratorTests autoload)
        (CustomLazyInitializationAccessMethodsCodeGeneratorTests autoload)
        (CustomLazyInitializationGetterMethodsCodeGeneratorTests autoload)
        CustomLocalChangeManager
        (CustomMultiSetterMethodsCodeGeneratorTests autoload)
        (CustomNamespaceTests autoload)
        CustomNoneSourceCodeFormatter
        CustomRBLocalSourceCodeFormatter
        CustomRefactoring
        (CustomRefactoryBuilderTests autoload)
        (CustomReplaceIfNilWithIfTrueRefactoringTests autoload)
        CustomSilentDialog
        (CustomSimpleAccessMethodsCodeGeneratorTests autoload)
        (CustomSimpleGetterMethodsCodeGeneratorTests autoload)
        (CustomSimpleSetterMethodsCodeGeneratorTests autoload)
        CustomSubContext
        (CustomSubclassResponsibilityCodeGeneratorTests autoload)
        (CustomTestCaseCodeGeneratorTests autoload)
        CustomUserDialog
        (CustomValueHolderAccessMethodsCodeGeneratorTests autoload)
        (CustomValueHolderGetterMethodsCodeGeneratorTests autoload)
        (CustomValueHolderWithChangeNotificationAccessMethodsCodeGeneratorTests autoload)
        (CustomValueHolderWithChangeNotificationGetterMethodsCodeGeneratorTests autoload)
        (CustomValueHolderWithChangeNotificationSetterMethodsCodeGeneratorTests autoload)
        (CustomVisitorCodeGeneratorAcceptVisitorTests autoload)
        (CustomVisitorCodeGeneratorTests autoload)
        CustomAccessMethodsCodeGenerator
        CustomCodeGeneratorClassGenerator
        CustomCodeSelectionToResourceTranslation
        CustomIsAbstractCodeGenerator
        CustomReplaceIfNilWithIfTrueRefactoring
        CustomSubclassResponsibilityCodeGenerator
        CustomTestCaseCodeGenerator
        CustomTestCaseMethodCodeGenerator
        CustomTestCaseSetUpCodeGenerator
        CustomTestCaseTearDownCodeGenerator
        CustomVisitorCodeGenerator
        CustomChangeNotificationAccessMethodsCodeGenerator
        CustomChangeNotificationSetterMethodsCodeGenerator
        CustomCodeGeneratorOrRefactoringTestCaseCodeGenerator
        CustomDefaultGetterMethodsCodeGenerator
        CustomLazyInitializationAccessMethodsCodeGenerator
        CustomLazyInitializationGetterMethodsCodeGenerator
        CustomMultiSetterMethodsCodeGenerator
        CustomSimpleAccessMethodsCodeGenerator
        CustomSimpleGetterMethodsCodeGenerator
        CustomSimpleSetterMethodsCodeGenerator
        CustomUITestCaseCodeGenerator
        CustomUITestCaseSetUpCodeGenerator
        CustomValueHolderAccessMethodsCodeGenerator
        CustomValueHolderGetterMethodsCodeGenerator
        CustomValueHolderWithChangeNotificationAccessMethodsCodeGenerator
        CustomValueHolderWithChangeNotificationGetterMethodsCodeGenerator
        CustomValueHolderWithChangeNotificationSetterMethodsCodeGenerator
        CustomVisitorCodeGeneratorAcceptVisitor
    )
!

extensionMethodNames
    "list class/selector pairs of extensions.
     A correponding method with real names must be present in my concrete subclasses"

    ^ #(
        #'Tools::NewSystemBrowser' selectorMenuExtensionCustomRefactorings:
        #'Tools::NewSystemBrowser' classMenuExtensionCustomGenerators:
        #'Tools::NewSystemBrowser' codeViewMenuExtensionCustomRefactorings:
        #'Tools::NewSystemBrowser' selectorMenuExtensionCustomGenerators:
        #'Tools::NewSystemBrowser' variablesMenuExtensionCustomGenerators:
        RBAbstractClass allClassVarNames
        RBAbstractClass allSuperclassesDo:
        RBAbstractClass instVarNames
        RBAbstractClass methodDictionary
        RBAbstractClass nameWithoutPrefix
        RBAbstractClass superclassName:
        RBAbstractClass theMetaclass
        RBAbstractClass theNonMetaclass
        RBAbstractClass withAllSuperclassesDo:
        RBClass compile
        RBClass theNonMetaClass
        RBMetaclass theMetaClass
        RBMetaclass theMetaclass
        RBAbstractClass instVarNames:
        RBMethod sends:or:
        RBAbstractClass isModelClass
        RBMethod category:
        RBMethod class:
        RBMethod compile
        RBMethod methodArgNames
        RBMethod methodDefinitionTemplate
        RBMethod model
        RBMethod model:
        RBMethod protocol
        RBMethod protocol:
        RBMethod replace:with:
        RBMethod sourceCodeGenerator
        RBMethod sourceCodeGenerator:
        AddClassChange package
        AddClassChange package:
        AddMethodChange package:
        RBAbstractClass compileMethod:
        RBAbstractClass package
        RBAbstractClass package:
        RBMethod newSource
        RBMethod package:
        RBAbstractClass inheritsFrom:
        RBAbstractClass isSubclassOf:
    )
! !

!jn_refactoring_custom class methodsFor:'description - project information'!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'My Company'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Class Library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'My CopyRight or CopyLeft'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'ProductName'
! !

!jn_refactoring_custom class methodsFor:'documentation'!

version_HG
    ^ '$Changeset: <not expanded> $'
! !

