"{ Package: 'jn:refactoring_custom/patches' }"!

!AddClassChange methodsFor:'private'!

primitiveExecute

    package notNil ifTrue:[
        Class packageQuerySignal 
            answer:package
            do:[
                ^ self definingSuperclass subclassDefinerClass 
                    evaluate: definition
                    notifying: self controller
                    logged: true
            ]
    ].

    ^ self definingSuperclass subclassDefinerClass 
                evaluate: definition
                notifying: self controller
                logged: true

    "Modified: / 08-10-2014 / 20:10:02 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!AddMethodChange methodsFor:'converting'!

asUndoOperation
^(self changeClass includesSelector: self selector) 
ifTrue: 
[| oldProtocol oldPackage |
oldProtocol := BrowserEnvironment new whichProtocolIncludes: self selector
in: self changeClass.
oldProtocol isNil ifTrue: [oldProtocol := #accessing].
oldPackage := (self changeClass compiledMethodAt: self selector) package.
(AddMethodChange 
compile: (self methodSourceFor: self selector)
in: self changeClass
classified: oldProtocol) 
package: oldPackage;
yourself]
ifFalse: [RemoveMethodChange remove: selector from: self changeClass]

"Modified: / 17-10-2014 / 10:22:09 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!RBAbstractClass methodsFor:'method accessing'!

compile: aString classified: aSymbolCollection 
        | change method |
        change := model 
                                compile: aString
                                in: self
                                classified: aSymbolCollection.
        method := RBMethod 
                                for: self
                                source: aString
                                selector: change selector.
        method category: aSymbolCollection.
        self addMethod: method

    "Modified: / 06-10-2014 / 22:38:27 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!RBAbstractClass methodsFor:'method accessing'!

compileTree: aBRMethodNode classified: aSymbolCollection 
        | method source |
        source := aBRMethodNode formattedCode.
        model 
                compile: source
                in: self
                classified: aSymbolCollection.
        method := RBMethod 
                                for: self
                                source: source
                                selector: aBRMethodNode selector.
        method category: aSymbolCollection.
"       method parseTree: aBRMethodNode."
        self addMethod: method

    "Modified: / 06-10-2014 / 22:37:13 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!RBAbstractClass methodsFor:'method accessing'!

compileTree: aBRMethodNode usingSource:newSource classified: aSymbolCollection 
        | method source |

        source := newSource.
        model 
                compile: source
                in: self
                classified: aSymbolCollection.
        method := RBMethod 
                                for: self
                                source: newSource
                                selector: aBRMethodNode selector.
        method category: aSymbolCollection.
"       method parseTree: aBRMethodNode."
        self addMethod: method

    "Modified: / 06-10-2014 / 22:38:57 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!RBMethod methodsFor:'accessing'!

category
    "Returns in which category/protocol does the method belongs within a class"

    | category |

    category := self objectAttributeAt: #category.  

    category isNil ifTrue: [  
        | compiledMethod |

        compiledMethod := self method.
        compiledMethod notNil ifTrue:[
            ^ compiledMethod category.
        ].

        ^ 'as yet unclassified'
    ].

    ^ category

    "Created: / 17-02-2012 / 00:06:20 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified (comment): / 06-10-2014 / 07:55:28 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!RBMethod methodsFor:'accessing'!

info
    "Returns an 'info object' that can answer various
     questions like 'what selectors method sends',
     names if temporaries etc.

     Actally, 'info object' is instance of Parser"

    info isNil ifTrue:[
        info := Parser 
            parseMethod: self source
            in:nil
            ignoreErrors:true
            ignoreWarnings:true
    ].
    ^info

    "Created: / 16-02-2012 / 16:33:09 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 04-10-2014 / 10:13:01 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!RBMethod methodsFor:'accessing'!

method
    "Returns Method instance which is present or retrived from real class"

    (compiledMethod isNil and: [ class notNil ]) ifTrue:[
        | realClass selector |

        realClass := class realClass.
        selector := self selector.

        "Do not try to retrieve method when its not possible"
        (realClass notNil and: [ selector notNil ]) ifTrue: [ 
            compiledMethod := realClass compiledMethodAt: selector.
        ]
    ].
    ^compiledMethod

    "Modified: / 17-02-2012 / 00:07:48 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 08-10-2014 / 18:52:37 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!RBMethod methodsFor:'accessing'!

package
    "see Method >> package ( same purpose, but for model method )"
    | package |

    package := self objectAttributeAt: #package.

    package isNil ifTrue: [ 
        | method |

        method := self method.

        method isNil ifTrue: [ 
            package := PackageId noProjectID
        ] ifFalse: [ 
            package := method package
        ]
    ].

    ^ package

    "Created: / 17-02-2012 / 00:41:36 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 10-10-2014 / 11:11:36 / Jakub Nesveda <nesvejak@fit.cvut.cz>"
! !

!jn_refactoring_custom_patches class methodsFor:'documentation'!

extensionsVersion_HG

    ^ '$Changeset: <not expanded> $'
! !
